//
// ifelse.cocci, 12 Oct 24

@ if_1
disable neg_if
@
expression E_1;
statement S_1;
position p_1, p_2;
@@
if@p_1 (E_1)
   S_1@p_2
@

script:python @ expr_1 << if_1.E_1;
                loc_1 << if_1.p_1;
                loc_2 << if_1.p_2;
              @@

import sys
def printf(format, *args):
    sys.stdout.write(format % args)

# file;stmt;if_line;if_col;cmpd_start;cmpd_end;expr

printf("%s;if", loc_1[0].file)
printf(";%s;%s", loc_1[0].line, loc_1[0].column)
printf(";%s;%s", loc_2[0].line, loc_2[0].line_end)
printf(";%s\n", expr_1.replace(';', ':'))


@ if_else_1
disable neg_if
@
expression E_1;
statement S_1, S_2;
position p_1, p_2, p_3, p_4;
@@
if@p_1 (E_1)
   S_1@p_2
else@p_3
   S_2@p_4
@

script:python @ expr_1 << if_else_1.E_1;
                loc_1 << if_else_1.p_1;
                loc_2 << if_else_1.p_2;
                loc_3 << if_else_1.p_3;
                loc_4 << if_else_1.p_4;
              @@

import sys
def printf(format, *args):
    sys.stdout.write(format % args)

printf("%s;if", loc_1[0].file)
printf(";%s;%s", loc_1[0].line, loc_1[0].column)
printf(";%s;%s", loc_2[0].line, loc_2[0].line_end)
printf(";%s\n", expr_1.replace(';', ':'))
printf("%s;else", loc_1[0].file)
printf(";%s;%s", loc_3[0].line, loc_3[0].column)
printf(";%s;%s", loc_4[0].line, loc_4[0].line_end)
printf(";###\n")


// 
// @ func_def
// disable neg_if
// @
// identifier f;
// position p_1, p_2;
// @@
// f(...)
// {@p_1
// ...
// }@p_2
// @
// 
// script:python @ func << func_def.f;
// 		loc_1 << func_def.p_1;
//                 loc_2 << func_def.p_2;
//               @@
// 
// import sys
// def printf(format, *args):
//     sys.stdout.write(format % args)
// 
// printf("%s;fun", loc_1[0].file)
// printf(",%s,%s", loc_1[0].line, loc_1[0].column)
// printf(",%s,%s", loc_2[0].line, loc_2[0].column)
// printf(",%s\n", func)

